Attribute VB_Name = "BckGround"
Option Explicit
 
Type BackGround
    position As point
    picsource As StdPicture
    hsourceDC As Long
    Leftside As Integer
    Rightside As Integer
    End Type
    
Type Floor
    top As Integer
    bottom As Integer
    left As Integer
    right As Integer
    Roof As Integer
End Type

Type BackPic
    position As point
    picsource As StdPicture
    hsourceDC As Long
    picmask As StdPicture
    hmaskDc As Long
    CellTop As Integer
    CellWidth As Integer
    CellHeight As Integer
    CellCount As Integer
    
End Type
Public Score As BackPic
Public Const Floormax = 7
Public floors(0 To Floormax) As Floor
Public backdrop As BackGround
Public offscreenDC As Long
Public offscreenBmp As Long
Public Scorenum As Long
Public Points As Integer
Public ScorePos As point
Public platform As BackPic
  

Public Sub Backset()
    Dim htempDC As Long
    Dim hOldBmp As Long
    Floorset
    backdrop.position.x = 0
    backdrop.position.y = 0
    'Initialize backdrop
    backdrop.Leftside = 0
    backdrop.Rightside = 640
    htempDC = GetDC(0)
    Set backdrop.picsource = New StdPicture
    Set backdrop.picsource = LoadPicture(App.Path & "\warthhogmania.bmp")
    backdrop.hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(backdrop.hsourceDC, backdrop.picsource.Handle)
    ReleaseDC 0, htempDC
End Sub

Public Sub backdraw()
    BitBlt offscreenDC, backdrop.position.x, backdrop.position.y, 800, 600, backdrop.hsourceDC, 0, 0, vbSrcCopy
End Sub

Public Sub Screenset()
    Dim htempDC As Long
    Dim hOldBmp As Long
    htempDC = GetDC(0)
    offscreenDC = CreateCompatibleDC(htempDC)
    offscreenBmp = CreateCompatibleBitmap(htempDC, 640, 480)
    hOldBmp = SelectObject(offscreenDC, offscreenBmp)
    ReleaseDC 0, htempDC
End Sub

Public Sub Floorset()
    'setting the basement floor'
    floors(0).left = -50
    floors(0).right = 700
    floors(0).top = 415
    floors(0).bottom = 440
    floors(0).Roof = floors(0).top - 5
    
    'setting the bottom right'
    floors(1).left = -50
    floors(1).right = 235
    floors(1).top = 320
    floors(1).bottom = 325
    floors(1).Roof = floors(1).top - 5
    
    'setting the bottom left'
    floors(2).left = 406
    floors(2).right = 700
    floors(2).top = 320
    floors(2).bottom = 325
    floors(2).Roof = floors(2).top - 5
    'setting the middle left'
    floors(3).left = -50
    floors(3).right = 99
    floors(3).top = 218
    floors(3).bottom = 232
    floors(3).Roof = floors(3).top - 1
    'setting the middle right'
    floors(4).left = 548
    floors(4).right = 700
    floors(4).top = 218
    floors(4).bottom = 232
    floors(4).Roof = floors(4).top - 1
    'setting the Centre'
    floors(5).left = 166
    floors(5).right = 465
    floors(5).top = 204
    floors(5).bottom = 250
    floors(5).Roof = floors(5).top - 1
    'setting the top left'
    floors(6).left = -50
    floors(6).right = 266
    floors(6).top = 96
    floors(6).bottom = 110
    floors(6).Roof = floors(6).top - 1
    'setting the the top right'
    floors(7).left = 380
    floors(7).right = 700
    floors(7).top = 96
    floors(7).bottom = 110
    floors(7).Roof = floors(7).top - 1
    End Sub


Public Sub Scoreset()
Dim htempDC As Long
    Dim hOldBmp As Long
    Dim Bmtemp As BITMAP
    'Ititialize score's Movement
    ScorePos.x = 333
    ScorePos.y = 5
        Score.position = ScorePos
    ' Initialize score's Picture
    htempDC = GetDC(0)
     Set Score.picsource = New StdPicture
    Set Score.picsource = LoadPicture(App.Path & "\halonumbers.bmp")
    Score.hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Score.hsourceDC, Score.picsource.Handle)
    
    Set Score.picmask = New StdPicture
    Set Score.picmask = LoadPicture(App.Path & "\msknum.bmp")
    Score.hmaskDc = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(Score.hmaskDc, Score.picmask.Handle)
     Score.CellTop = 0
     Score.CellCount = 10
     GetObject Score.picsource.Handle, Len(Bmtemp), Bmtemp
     Score.CellWidth = Bmtemp.bmWidth
     Score.CellHeight = Bmtemp.bmHeight / Score.CellCount
    ReleaseDC 0, htempDC
    Scorenum = 0
    Points = 100
    
      
End Sub

Public Sub ScoreDraw()
    Dim scoreTop As Long
    Dim scoreLeft As Long
    Dim scoreacross As Long
    Dim scoredown As Long
    scoreTop = Score.position.y
    scoreLeft = Score.position.x
    scoreacross = Score.CellWidth
    scoredown = Score.CellHeight
    BitBlt offscreenDC, scoreLeft, scoreTop, scoreacross, scoredown, Score.hmaskDc, 0, Score.CellTop, vbSrcAnd
    BitBlt offscreenDC, scoreLeft, scoreTop, scoreacross, scoredown, Score.hsourceDC, 0, Score.CellTop, vbSrcPaint
End Sub


Public Sub Scoreget()
Dim Digit As Integer
Dim Tscore As Long
If Scorenum = 0 Then
Score.CellTop = 0
ScoreDraw
Else
Tscore = Scorenum
Do While Tscore > 0
Digit = Tscore Mod 10
Tscore = Int(Tscore / 10)
Score.CellTop = Digit * Score.CellHeight
Score.position.x = Score.position.x - Score.CellWidth
ScoreDraw
Loop
End If
Score.position = ScorePos
End Sub

Public Sub platformset()
Dim htempDC As Long
    Dim hOldBmp As Long
    Dim Bmtemp As BITMAP
    ' Initialize platform's Picture
    htempDC = GetDC(0)
     Set platform.picsource = New StdPicture
    Set platform.picsource = LoadPicture(App.Path & "\platform.bmp")
    platform.hsourceDC = CreateCompatibleDC(htempDC)
    hOldBmp = SelectObject(platform.hsourceDC, platform.picsource.Handle)
    
     platform.CellTop = 0
     platform.CellCount = 10
     GetObject platform.picsource.Handle, Len(Bmtemp), Bmtemp
     platform.CellWidth = Bmtemp.bmWidth
     platform.CellHeight = Bmtemp.bmHeight / platform.CellCount
    ReleaseDC 0, htempDC
    
End Sub

Public Sub platformdraw()
Dim platformTop As Long
    Dim platformLeft As Long
    Dim platformacross As Long
    Dim platformdown As Long
    platformTop = platform.position.y
    platformLeft = platform.position.x
    platformacross = platform.CellWidth
    platformdown = platform.CellHeight
    BitBlt offscreenDC, platformLeft, platformTop, platformacross, platformdown, platform.hmaskDc, 0, platform.CellTop, vbSrcAnd
    BitBlt offscreenDC, platformLeft, platformTop, platformacross, platformdown, platform.hsourceDC, 0, platform.CellTop, vbSrcPaint
End Sub
